function [CS, IndMax, Pmax, FF, YY, Y] = compressedspectrum(Y1,m,Fs)
% function [CS, IndMax, FF, YY, Y] = compressedspectrum(Y1,m,Fs,nfft)

% Y1 = standata(Y1);

if nargin < 2 | isempty(m)
    m = 3;
end

if nargin < 3 | isempty(Fs)
    Fs = 1000;
end

% if nargin < 4 | isempty(nfft)
%     nfft = 10*Fs;
% end

Fmin = 4; %3
Fmax = 12; %12

nfft = 8192;

% Y = Y1(:,1:3*Fs);  %prendo segnale di circa 2s
% [B,A] = cheby2(6,60,[2.5/(Fs/2) 25/(Fs/2)],'stop');
% Y = filtfilt(B,A,Y1);

Y = Y1;
% Y = Y1(:,1:3*Fs);
% Idz = find(Y<0);
% Y(Idz) = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% n = (0:length(Y)-1)/Fs;
% % 
% % % FF = logspace(0,2,1024);
% % % 
% % % YY = exp(-i*2*pi*FF'*n)*Y';
% f0 = 2.5;
% fmax = 25;
% nfft = 1024;
% % nfft = 2^ceil(log(length(Y))/log(2))
% a = (fmax/f0)^(nfft/(nfft-1));
% 
% K = 0:nfft-1;
% FF = f0*a.^(K./nfft);
% % FF = f0*10.^(K./nfft);
% 
% YY = exp(-i*2*pi*FF'*n)*Y';
% 
% % YY = YY.*YY;
% 
% for k = 4:length(YY)
%     CS(k) = 0;
%     for j = 1:m
%         if j*k+3 <= length(YY)
%             CS(k) = CS(k) + sum(abs(YY(j*k-3:j*k+3)));
%         end
%     end
%     CS(k) = 2*CS(k);
% end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% [YYq,FF] = pwelch(Y,[],[],8192,1000);
% 
% for k = 1:length(abs(YYq))
%     CSq(k) = 0;
%     for j = 1:m
%         if j*k <= length(YYq)
%             if FF(j*k) <= 25
%                 CSq(k) = CSq(k) + abs(YYq(j*k));
%             end
%         end
%     end
%     CSq(k) = 2*CSq(k);
% end
% 
% Iqq = find(FF<0.5,1,'last');
% 
% [MMq, Imq] = max(CSq(find(FF >= 0.5 & FF < 2)));
% Indqq = FF(Imq+Iqq)
% 
% Y = notch(Y,Indqq,Fs);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% THRESHOLD

% thresh = 2*mean(abs(Y));
thresh = mean(abs(Y));

idx = [];
count = 0;
for i = 2:length(Y)
    if Y(i) >= -thresh && Y(i) <= thresh
        Y(i) = Y(i);
        count = 0;
    else Y(i) = Y(i-1);
        count = count+1;
        if count == 1
            idx = [idx;i];
        end
        
    end
end


% [Y] = AAbswander2(Y,Fs,2);
% 
% plot((0:length(fft(Y))-1)./length(Y)*1000,abs(fft(Y)))
% YY = fft(Y);
% FF = (0:length(fft(Y))-1)./length(Y)*Fs;
% Iadd = find(FF<Fmin,1,'last');
% Ia = find(FF >= Fmin & FF <= 12);
% [ma, Inda] = max(abs(YY(Ia)));
% IndMax = FF(Inda+Iadd)
% CS = 1;
%     
% return

% [Y] = AAbswander2(Y,Fs,2);

%%
% 
if Fs > 128
[B,A] = cheby2(3,20,[1/(Fs/2) 75/(Fs/2)]);
else
    [B,A] = cheby2(3,20,[3/(Fs/2) 60/(Fs/2)]);
end
plot(Y)
Y = filtfilt(B,A,Y);
% Y = detrend(Y,1,idx);

%%

% YY = abs(fft(Y));
% FF = (0:length(fft(Y))-1)./length(Y)*Fs;

[YY,FF] = pwelch(Y,[],[],nfft,Fs);

% for k = 3:length(YY)
%     CS(k) = 0;
%     for j = 1:m
%         if j*k+2 <= length(YY)
%             CS(k) = CS(k) + sum(abs(YY(j*k-2:j*k+2)));
%         end
%     end
%     CS(k) = 2*CS(k);
% end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
CS = YY;%zeros(size(YY));
for k = 2:length(abs(YY))-1
    if abs(YY(k)) > abs(YY(k-1)) & abs(YY(k)) > abs(YY(k+1))
    for j = 1:m
        if j*k <= length(YY)
            if FF(k) >= Fmin & FF(k) <= Fmax
                CS(k) = CS(k) + abs(YY(j*k-(j-1)));
                % csp(k) = csp(k) + sum(abs(YY(j*k-(j-1))));
            end
        end
    end
    end
    CS(k) = 2*CS(k);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CS = YY;
% for k = 1:length(abs(YY))
%     for j = 1:m
%         if j*k <= length(YY)
%             if FF(k) >= Fmin & FF(k) <= 25
%                 CS(k) = CS(k) + sum(abs(YY(j*k -(j-1):j*k+(j-1))));
%             end
%         end
%     end
%     CS(k) = 2*CS(k);
% end

% csp(k) = csp(k) + sum(abs(YY(j*k-(j-1))));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % CS= abs(fft(Y));
% CS = YY;
% ffo = FF;
% Irro = find(ffo >= Fmin & ffo <= 12);
% [mmo, Indrro] = max(CS(Irro));
% Foo(i,:) = ffo(Indrro+Irro(1)-1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot(FF(find(FF<50)),CS(find(FF<50)))  %figure

% plot(FF(find(FF<25)),CS(find(FF<25)))

% figure, semilogx(FF(find(FF<50)),CS(find(FF<50)))
% figure, semilogy(FF(find(FF<50)),CS(find(FF<50)))
% figure, loglog(FF(find(FF<50)),CS(find(FF<50)))
% t = log(FF(find(FF<50)));
% plot(t,CS(find(FF<50)))

Iadd = find(FF<Fmin,1,'last');

[MM, Im] = max(CS(find(FF >= Fmin & FF < Fmax)));

IndMax = FF(Im+Iadd);

Pmax = CS(Im+Iadd);
